*DECK LIBWID
      FUNCTION LIBWID(NEL,IWISO,ISOID)
C
C-------------------------- LIBWID   ----------------------------------
C
C  PROGRAMME STATISTICS:
C     NAME     : LIBWID
C     ENTRY    : LIBWID
C     USE      : FIND ISOTOPE NUMBER ASSOCIATED WITH ISOTOPE ID
C                ON WIMS-NEA AND WIMS-AECL LIBRARY
C     MODIFIED : 97-01-00
C     AUTHOR   : G. MARLEAU
C
C  ROUTINE PARAMETERS:
C   INPUT
C     NEL    : NUMBER OF ISOTOPES ON WIMS-NEA       I
C     IWISO  : ID OF ISOTOPE ON WIMS-NEA            I(NEL)
C     ISOID  : ISOTOPE ID REQUESTED                 I
C   OUTPUT
C     LIBWID : ISOTOPE NUMBER ASSOCIATED WITH ID    I
C              = 0 WHEN ISOTOPE ID IS NOT FOUND
C
C--------------------------  LIBWID  ----------------------------------
C
      IMPLICIT NONE
      INTEGER      NEL,IWISO(NEL),ISOID,LIBWID,IEL
C----
      LIBWID=0
      IF(ISOID.GT.0) THEN
        DO 100 IEL=1,NEL
          IF(IWISO(IEL).EQ.ISOID) THEN
            LIBWID=IEL
            GO TO 105
          ENDIF
 100    CONTINUE
 105    CONTINUE
      ENDIF
      RETURN
      END
