*DECK MOC2DR
      SUBROUTINE MOC2DR(IPFLUX,IFTRAK,NGRP,NREG,NSOUT, NANIS,NMAT,NGSS,
     >              MXSEG, NTRK, NPHI, NFUNL, NMOD, KEYANI,
     >              MATALB,VOL,VOLINV,WGSS,XGSS,YGSS,PHIANG,
     >              SEGLEN,NRSEG,EXPT,EXP2,CYCLE,FLM,FLP,CYP,CYM,
     >              ALPHA,DFLUX,DWEIG,FMEAN,
     >              SIGANG,NALB,ALBEDO,XSTOT,XSTRC,
     >              XTINV,XSDIA,XSCAT,
     >              NIFIS,XSNUF,XSCHI,ITRB,
     >              FLUX,FLUXO,DIFFB1,ISGNR,RHARM,
     >              LEAKSW,LREBAL,
     >              NINTMX,AIEPSF,NEXTMX,AEEPSF,IPRT,ITYPEC,ILEAK,
     >              NL,NBN,RKEFF,RB2,
     >              TRHAR,REBAL,CPTL,CPTA,
     >              PHI,FLUN,PNL,XCSOU,
     >              XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >              DIFF,DB2,BETA,LEXIN,NOVOID,REFKEF )
*
C
C     FLUX(,,,1) <= OLD     OUTER
C     FLUX(,,,2) <= PRESENT OUTER
C     FLUX(,,,3) <= NEW     OUTER
C     FLUX(,,,4) <= SOURCE  OUTER
C     FLUX(,,,5) <= OLD     INNER
C     FLUX(,,,6) <= PRESENT INNER
C     FLUX(,,,7) <= NEW     INNER
C     FLUX(,,,8) <= SOURCE  INNER
C
      IMPLICIT NONE
*
      INTEGER NGRP,NREG,NANIS,NMAT,NGSS,MXSEG,NTRK,NSOUT,MXGAUS,
     >        IPRT,ITYPEC,IFTRAK,NPHI,NFUNL,NMOD,
     >        NL,NBN,IPFLUX,ITRB,NALB,
     >        CPTL,CPTA,CTOT,CPTM,MAXITR,IOUT
      INTEGER MATALB(-NSOUT:NREG),NRSEG(MXSEG),KEYANI(NFUNL),
     >        ISGNR(NFUNL,NMOD)
      INTEGER IR,IG,JG,IA,IT,JT,IS,ITERF,IGDEB,IGDEBO
      INTEGER NEXTMX,NINTMX,IEXTF,ILEAK,NIFIS
      PARAMETER(IOUT=6,MXGAUS=64)
      REAL    SEGLEN(MXSEG),ALBEDO(NALB), RKEFF, RB2
      REAL    EXPT(NGSS,MXSEG),EXP2(NGSS,MXSEG),
     >        CYCLE(NGSS),FLM(NGSS,MXSEG),SIGANG(NGSS,-NALB:NMAT,NGRP),
     >        FLP(NGSS,MXSEG),CYM(NGSS,MXSEG),CYP(NGSS,MXSEG),
     >        XSTOT(0:NMAT,NGRP),XSTRC(0:NMAT,NGRP),XSDIA(0:NMAT,NGRP),
     >        XSCAT(NGRP,0:NMAT,0:NANIS,NGRP),XTINV(0:NMAT,NGRP),
     >        WGSS(MXGAUS),XGSS(MXGAUS),YGSS(MXGAUS),PHIANG(NPHI),
     >        XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP)
      REAL    ALPHA(NGSS),DFLUX(NGSS),DWEIG(NGSS),FMEAN(NGSS)
      DOUBLE PRECISION PHI(NGRP),XCSOU(NGRP),XCTOT(NGRP),XCABS(NGRP),
     >        XCCAT(NGRP,0:NANIS,NGRP),DIFF(NGRP),DB2(NGRP),PNL(NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP),XCTRC(NGRP),XCDIA(NGRP),AKEEP(8)
      REAL    VOL(NREG),VOLINV(NREG),FLUX(NFUNL,NREG,NGRP,8),
     >        FLUXO(NREG,NFUNL,NGRP),DIFFB1(NGRP),
     >        RHARM(NGSS,*),TRHAR(NFUNL,NGSS,*),
     >        EINN,EEXT,FINN,GINN,EIMX,EEMX,EBMX,MU,
     >        AIEPSF,AEEPSF,FACT,ONE,ZERO
      DOUBLE PRECISION AFLNOR, FISOUR, AKEFF, AKEFFO, OLDBIL,
     >        B2VAL, B2VALO, BFLNOR, AKFRB, OOL
      DOUBLE PRECISION DONE, DZERO, DTHIRD, REFKEF
      DOUBLE PRECISION REBAL(NGRP,NGRP+1),BETA(NGRP),FLUN(NGRP)
      LOGICAL LEAKSW,LREBAL,NOVOID,LEXACT,LEXIN
      CHARACTER*8 NAMFLX
      CHARACTER*5 MESSIN, MESSOU
      PARAMETER (  ZERO=0.0,    ONE=1.0,
     >            DZERO=0.0D0, DONE=1.0D0, DTHIRD=DONE/3.0D0 )
C
      LEXACT= LEXIN
      OOL= DZERO
      EBMX= 1.E-6
      AKEEP(5)=DONE
      AKEEP(6)=DONE
      AKEEP(7)=DONE
      IF( IPRT.GT.1 )THEN
         WRITE(IOUT,999)
      ENDIF
C
C     INCLUDE FACTOR (2*IA+1) IN *XSCAT*
      IF( NANIS.GT.0 )THEN
         DO 31 JG=1,NGRP
         DO 21 IA=1,NANIS
         DO 11 IR=1,NMAT
         DO  1 IG=1,NGRP
            XSCAT(IG,IR,IA,JG)= REAL(2*IA+1)*XSCAT(IG,IR,IA,JG)
    1    CONTINUE
   11    CONTINUE
   21    CONTINUE
   31    CONTINUE
      ENDIF
C
C     WE COULD HAVE PERFORMED TRANSPORT CORRECTION
      DO 1003 IG=1,NGRP
         DB2(IG)= DZERO
         PNL(IG)= DONE
 1003 CONTINUE
C
C     FILL-UP FOR SIGANG
      DO 30 JG=1,NGRP
      DO 20 IG=1,NGSS
         DO 13 IR=-NALB,-1
            SIGANG(IG,IR,JG)= ONE-ALBEDO(-IR)
   13    CONTINUE
         SIGANG(IG,0,JG) = ZERO
         DO 10 IR=1,NMAT
            SIGANG(IG,IR,JG) = XSTRC(IR,JG) * YGSS(IG)
   10     CONTINUE
   20 CONTINUE
   30 CONTINUE
C
C     EXTERNAL FLUX(,,,2) INITIALISATION
C      AND FIXED-EXTERNAL SOURCE IN FLUX(,,,4)
      AKEFFO= DZERO
      DO 22 IG= 1, NGRP
         XCSOU(IG)= DZERO
         WRITE(NAMFLX,'(4HFLUX,I3,1X)') IG
         CALL LCMGET(IPFLUX,NAMFLX,FLUXO(1,1,IG))
         DO 12 IR= 1, NREG
            FLUX(1,IR,IG,2) = FLUXO(IR,1,IG)
            IF( ITYPEC .EQ. 6 )THEN
                FLUX(1,IR,IG,4) = XSNUF(MATALB(IR),1,IG)
                XCSOU(IG)= XCSOU(IG) + FLUX(1,IR,IG,4)*VOL(IR)
            ELSE
                FLUX(1,IR,IG,4) = ZERO
            ENDIF
            IF( NL.GT.0 )THEN
               DO 2 IA= 2, NFUNL
                  FLUX(IA,IR,IG,2) = ZERO
                  FLUX(IA,IR,IG,4) = ZERO
    2          CONTINUE
            ENDIF
   12    CONTINUE
   22 CONTINUE
C
C     COMPUTE FIRST K-EFFECTIVE
      IF( ITYPEC .EQ. 6 )THEN
         AKEFFO= DONE
         AKEFF=  DONE
         AFLNOR= DONE
      ELSE
         CALL MOC2HM(NGRP,NREG,NANIS,NMAT,NFUNL,NIFIS,KEYANI,MATALB(1),
     >               VOL,FLUX(1,1,1,2),
     >               XSTOT,XSTRC,XSDIA,XSCAT,XSNUF,XSCHI,
     >               PHI,
     >               XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,IPRT )
         CALL MOC2MH(1,NBN,NGRP,NANIS,
     >               PHI,XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >               DIFF,BETA,REBAL,FLUN,REFKEF,AKFRB,B2VAL,OOL,EBMX,1)
         DO 2200 IG= 1, NGRP
            DO 2210 IR= 1, NREG
               DO 2220 IS= 1, NFUNL
                  FLUX(IS,IR,IG,2)= FLUX(IS,IR,IG,2)
     >                            * FLUN(IG)/PHI(IG)
 2220          CONTINUE
 2210       CONTINUE
 2200    CONTINUE
         OLDBIL= DZERO
         CALL MOC2KF(NGRP,LEAKSW,OLDBIL,
     >               FLUN,XCABS,XCNUF,XCCHI,DB2,
     >               AKEFF,AFLNOR,IPRT)
         AKEFFO= AKEFF
         AKEEP(2)= AKEFF
      ENDIF
      B2VAL=  DZERO
      B2VALO= DZERO
C
      CTOT = CPTA+CPTL
      IF( CPTA.EQ.0 )THEN
         CPTM=CTOT+1
      ELSE
         CPTM= CPTA
      ENDIF
      MAXITR= 0
      EIMX=   AIEPSF
      EEMX=   AEEPSF
      FACT=   0.1
      MESSOU= '     '
      IF( IPRT.GT.0 )THEN
         WRITE(IOUT,2065) 0,ONE,EEMX,AKEFFO,B2VALO
      ENDIF
C
C***  OUTER LOOP
      IGDEB= 1
      DO 210 IT=1,NEXTMX
C
         MESSIN='     '
C
C        FISSION SOURCE CALCULATION IN FLUX(,,,4)
         IF( ITYPEC .LT. 6 )THEN
            IGDEB= 1
            DO 92 IG= 1, NGRP
               DO 91 IR= 1,NREG
                  FLUX(1,IR,IG,4)= ZERO
   91          CONTINUE
   92       CONTINUE
            DO 96 IR= 1,NREG
               DO 95 IS= 1,NIFIS
                  FISOUR= DZERO
                  DO 93 IG= 1, NGRP
                     FISOUR= FISOUR+
     >                       XSNUF(MATALB(IR),IS,IG)*FLUX(1,IR,IG,2)
   93             CONTINUE
                  FISOUR= FISOUR*AFLNOR
                  DO 94 IG= 1,NGRP
                     FLUX(1,IR,IG,4)= FLUX(1,IR,IG,4)+
     >                                XSCHI(MATALB(IR),IS,IG)*FISOUR
   94             CONTINUE
   95          CONTINUE
   96       CONTINUE
            DO 98 IG= 1, NGRP
               XCSOU(IG)= DZERO
               DO 97 IR= 1,NREG
                  XCSOU(IG)= XCSOU(IG)+FLUX(1,IR,IG,4)*VOL(IR)
   97          CONTINUE
   98       CONTINUE
         ENDIF
C
C        DOWNLOAD TO EXTERNAL FLUX(,,,2) TO PRESENT INTERNAL FLUX(,,,6)
         DO 783 IG= 1, NGRP
            DO 782 IR= 1, NREG
               DO 781 IS= 1, NFUNL
                  FLUX(IS,IR,IG,6)= FLUX(IS,IR,IG,2)
  781          CONTINUE
  782       CONTINUE
  783    CONTINUE
C
C***    INNER LOOP
        DO 500 JT= 1, NINTMX
C
C         FREE ITERATIONS
C         NORMALIZE FLUXES AND COMPUTE SOURCES
          IF( ITYPEC .EQ. 4 .AND. ILEAK .EQ. 2 )THEN
             DO 5 IG=IGDEB,NGRP
                PNL(IG)= XCTRC(IG)/(XCTRC(IG)+DB2(IG))
    5        CONTINUE
          ENDIF
          DO 65 IR= 1,NREG
             DO 45 IG= IGDEB,NGRP
C
C               COMPUTE SOURCES IN FLUX(,,,8)
                FLUX(1,IR,IG,8)= FLUX(1,IR,IG,4)
C
C               ADDING ISOTROPIC SCATTERING FROM PRESENT INTERNAL
                DO 35 JG= 1,NGRP
                   IF( IG.EQ.JG )THEN
                      FLUX(1,IR,IG,8)= FLUX(1,IR,IG,8)+
     >                XSDIA(MATALB(IR),IG)*FLUX(1,IR,JG,6)
                      IF( ITYPEC .EQ. 4 .AND. ILEAK .EQ. 3 )THEN
                         FLUX(1,IR,IG,8)= FLUX(1,IR,IG,8)-
     >                   DB2(IG)*FLUX(1,IR,JG,6)
                      ENDIF
                   ELSE
                      FLUX(1,IR,IG,8)= FLUX(1,IR,IG,8)+
     >                XSCAT(JG,MATALB(IR),0,IG)*FLUX(1,IR,JG,6)
                   ENDIF
   35           CONTINUE
                FLUX(1,IR,IG,8)= FLUX(1,IR,IG,8)
     >                         * XTINV(MATALB(IR),IG) * PNL(IG)
                IF( NL.GT.0 )THEN
C
C                  ADDING ANISOTROPIC SCATTERING, IF NEEDED
                   DO 55 IA= 2,NFUNL
                     FLUX(IA,IR,IG,8)= ZERO
                     DO 54 JG= 1,NGRP
                        FLUX(IA,IR,IG,8)= FLUX(IA,IR,IG,8)+
     >                            XSCAT(JG,MATALB(IR),KEYANI(IA),IG)*
     >                            FLUX(IA,IR,JG,6)
   54                CONTINUE
                     FLUX(IA,IR,IG,8)= FLUX(IA,IR,IG,8)
     >                                * XTINV(MATALB(IR),IG)
   55              CONTINUE
                ENDIF
   45      CONTINUE
   65    CONTINUE
C
C       FLUX COMPUTATION
         IF( LEXACT )THEN
            IF( NL.EQ.0 )THEN
               IF( NOVOID )THEN
                  CALL MOC3I1( IFTRAK, NGRP, NMAT, NREG, NGSS, NSOUT,
     >                   MXSEG, NTRK, MATALB, WGSS, SEGLEN, NRSEG,
     >                   EXPT, EXP2, FLM, FLP, CYM, CYP, NALB, SIGANG,
     >                   FLUX(1,1,1,8), FLUX(1,1,1,7), IGDEB )
               ELSE
                  CALL MOC3I0( IFTRAK, NGRP, NMAT, NREG, NGSS, NSOUT,
     >                   MXSEG, NTRK, MATALB, WGSS, YGSS, SEGLEN, NRSEG,
     >                   EXPT, EXP2, FLM, FLP, CYM, CYP, NALB, SIGANG,
     >                   FLUX(1,1,1,8), FLUX(1,1,1,7), IGDEB )
               ENDIF
            ELSE
               CALL XABORT('MOC2DR: ANISOTROPIC OPTION *N/A* YET')
            ENDIF
         ELSE
            IF( NL.EQ.0 )THEN
               IF( NOVOID )THEN
                  CALL MOC2I1( IFTRAK, NGRP, NMAT, NREG, NGSS, NSOUT,
     >                   MXSEG, NTRK, MATALB, WGSS, SEGLEN, NRSEG,
     >                   EXPT, EXP2, FLM, FLP, CYM, CYP, NALB, SIGANG,
     >                   FLUX(1,1,1,8), FLUX(1,1,1,7), IGDEB )
               ELSE
                  CALL MOC2I0( IFTRAK, NGRP, NMAT, NREG, NGSS, NSOUT,
     >                   MXSEG, NTRK, MATALB, WGSS, YGSS, SEGLEN, NRSEG,
     >                   EXPT, EXP2, FLM, FLP, CYM, CYP, NALB, SIGANG,
     >                   FLUX(1,1,1,8), FLUX(1,1,1,7), IGDEB )
               ENDIF
            ELSE
               CALL XABORT('MOC2DR: ANISOTROPIC OPTION *N/A* YET')
            ENDIF
         ENDIF
         DO 165 IR= 1,NREG
            DO 155 IA= 1,NFUNL
              DO 145 IG= IGDEB,NGRP
                  FLUX(IA,IR,IG,7) =
     >            (FLUX(IA,IR,IG,8) / REAL(2*KEYANI(IA)+1)
     >          + FLUX(IA,IR,IG,7) * XTINV(MATALB(IR),IG) * VOLINV(IR))
  145         CONTINUE
  155       CONTINUE
  165    CONTINUE
         MAXITR= MAXITR+1
         IF( LREBAL )THEN
         CALL MOC2HM(NGRP,NREG,NANIS,NMAT,NFUNL,NIFIS,KEYANI,MATALB(1),
     >               VOL,FLUX(1,1,1,7),
     >               XSTOT,XSTRC,XSDIA,XSCAT,XSNUF,XSCHI,
     >               PHI,
     >               XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,IPRT )
         CALL MOC2BL(NGRP,IGDEB,NANIS,PHI,XCSOU,XCTRC,XCDIA,XCCAT,DB2,
     >               REBAL,FLUN,IPRT)
         DO 1300 IG= IGDEB, NGRP
            DO 1310 IR= 1, NREG
               DO 1320 IS= 1, NFUNL
                  FLUX(IS,IR,IG,7)= FLUX(IS,IR,IG,7)
     >                            * FLUN(IG)
 1320          CONTINUE
 1310       CONTINUE
 1300    CONTINUE
         ENDIF
C
         IF( MOD(JT-1,CTOT).GE.CPTM )THEN
C
C           ACCELERATED INNER ITERATIONS
            CALL MOC2AC( NGRP, NFUNL, NREG, FLUX(1,1,1,5), AKEEP(5),
     >                   IGDEB, MU )
         ELSE
            MU= ONE
         ENDIF
         EINN= ZERO
         IGDEBO= IGDEB
         DO 220 IG= IGDEBO, NGRP
           GINN= ZERO
           FINN= ZERO
           DO 222 IR= 1, NREG
             DO 221 IA= 1, NFUNL
              GINN= MAX(GINN,ABS(FLUX(IA,IR,IG,6)-FLUX(IA,IR,IG,7)))
              FINN= MAX(FINN,ABS(FLUX(IA,IR,IG,7)))
              FLUX(IA,IR,IG,5)= FLUX(IA,IR,IG,6)
              FLUX(IA,IR,IG,6)= FLUX(IA,IR,IG,7)
  221        CONTINUE
  222      CONTINUE
           GINN= GINN/FINN
           IF( GINN.LT.EIMX.AND.IGDEB.EQ.IG ) THEN
             IGDEB= IGDEB+1
           ENDIF
           EINN=MAX(EINN,GINN)
  220    CONTINUE
        CALL MOCRWD( IFTRAK )
        ITERF= JT
        IF( IPRT.GT.1 )THEN
           WRITE(IOUT,2064) JT,EINN,EIMX,IGDEB,MU
        ENDIF
        IF( EINN.LT.EIMX ) GO TO 750
  500  CONTINUE
C***    INNER LOOP
C
       MESSIN='*NOT*'
  750  CONTINUE
       IF( IPRT.GT.1 )THEN
          WRITE(IOUT,1060) 'INTERNAL',MESSIN,ITERF
       ENDIF
C
C      PROMOTE TO NEW INTERNAL FLUX(,,,7) TO NEW EXTERNAL FLUX(,,,3)
       DO 763 IG= 1, NGRP
          DO 762 IR= 1, NREG
             DO 761 IS= 1, NFUNL
                FLUX(IS,IR,IG,3)= FLUX(IS,IR,IG,7)
  761        CONTINUE
  762     CONTINUE
  763  CONTINUE
C
       IF( ITYPEC .LT. 6 )THEN
C
C        HOMOGENIZE CELL
         CALL MOC2HM(NGRP,NREG,NANIS,NMAT,NFUNL,NIFIS,KEYANI,MATALB(1),
     >               VOL,FLUX(1,1,1,3),
     >               XSTOT,XSTRC,XSDIA,XSCAT,XSNUF,XSCHI,
     >               PHI,
     >               XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,IPRT )
         IF( IT.EQ.1 )THEN
C
C         INITIALIZE DIFFUSION COEFFICIENTS
             DO 1004 IG= 1, NGRP
                DIFF(IG)= DTHIRD/XCTRC(IG)
 1004        CONTINUE
         ENDIF
C
C         SOLVE BN EQUATION ON THE HOMOGENIZED CELL
         CALL MOC2MH(ITYPEC,NBN,NGRP,NANIS,
     >               PHI,XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >               DIFF,BETA,REBAL,FLUN,REFKEF,AKFRB,B2VAL,OOL,EBMX,1)
C
C        NORMALIZE FLUX(,,,3)
         DO 1200 IG= 1, NGRP
            DO 1210 IR= 1, NREG
               DO 1220 IS= 1, NFUNL
                  FLUX(IS,IR,IG,3)= FLUX(IS,IR,IG,3)
     >                            * FLUN(IG)/PHI(IG)
 1220          CONTINUE
 1210       CONTINUE
 1200    CONTINUE
C
       ENDIF
       IF( ITYPEC .EQ. 4 )THEN
C
          DO 335 IG=1,NGRP
             DB2(IG)= DIFF(IG)*B2VAL
  335     CONTINUE
          IF( B2VAL.EQ.DZERO )THEN
             BFLNOR= DONE
          ELSE
             BFLNOR= DONE/ABS(B2VAL)
          ENDIF
          EEXT= ABS(B2VAL-B2VALO)*BFLNOR
          B2VALO= B2VAL
       ENDIF
       IEXTF= IT
       IF( ITYPEC .LT. 6 )THEN
           CALL MOC2KF(NGRP,LEAKSW,OLDBIL,
     >                 FLUN,XCABS,XCNUF,XCCHI,DB2,
     >                 AKEFF,AFLNOR,IPRT)
           EEXT= ABS(AKEFF-AKEFFO)/AKEFF
       ELSE
           EEXT= DZERO
       ENDIF
       AKEEP(3)= AKEFF
       IF( MOD(IT-1,CTOT).GE.CPTM )THEN
C
C         ACCELERATED OUTER ITERATIONS
          CALL MOC2AC( NGRP, NFUNL, NREG, FLUX(1,1,1,1), AKEEP(1),
     >                 1, MU )
       ELSE
          MU= ONE
       ENDIF
       IF( ITYPEC .LT. 6 )THEN
           IF( IPRT.GT.0 )THEN
              WRITE(IOUT,2065) IT,EEXT,EEMX,AKEFF,B2VAL
           ENDIF
           IF( EEXT.LT.EEMX )THEN
C
C           COMPARE FLUX FOR OUTER ITERATIONS
            EINN= ZERO
            DO 322 IG= 1, NGRP
             GINN= ZERO
             FINN= ZERO
             DO 321 IR= 1, NREG
              DO 320 IA= 1, NFUNL
                GINN= MAX(GINN,ABS(FLUX(IA,IR,IG,2)-FLUX(IA,IR,IG,3)))
                FINN= MAX(FINN,ABS(FLUX(IA,IR,IG,3)))
                FLUX(IA,IR,IG,1)= FLUX(IA,IR,IG,2)
                FLUX(IA,IR,IG,2)= FLUX(IA,IR,IG,3)
  320         CONTINUE
  321        CONTINUE
             GINN= GINN/FINN
             EINN= MAX(EINN,GINN)
  322       CONTINUE
            IF( IPRT.GT.0 )THEN
             WRITE(IOUT,2066) IT,EINN,EIMX,AFLNOR,MU
            ENDIF
           ELSE
            DO 325 IG= 1, NGRP
             DO 324 IR= 1, NREG
              DO 323 IA= 1, NFUNL
                FLUX(IA,IR,IG,1)= FLUX(IA,IR,IG,2)
                FLUX(IA,IR,IG,2)= FLUX(IA,IR,IG,3)
  323         CONTINUE
  324        CONTINUE
  325       CONTINUE
            IF( IPRT.GT.0 )THEN
             WRITE(IOUT,2067) IT,AFLNOR,MU
            ENDIF
           ENDIF
       ELSE
         DO 425 IG= 1, NGRP
          DO 424 IR= 1, NREG
           DO 423 IA= 1, NFUNL
             FLUX(IA,IR,IG,1)= FLUX(IA,IR,IG,2)
             FLUX(IA,IR,IG,2)= FLUX(IA,IR,IG,3)
  423      CONTINUE
  424     CONTINUE
  425    CONTINUE
       ENDIF
        AKEEP(1)= AKEEP(2)
        AKEEP(2)= AKEEP(3)
        AFLNOR= (AKEFF/AKEEP(3))*AFLNOR
C
C       UPDATE KEFF
        AKEFFO= AKEFF
        IF( EEXT.LT.EEMX .AND. EINN.LT.EIMX )THEN
           IF( LEXACT ) GO TO 240
C
C          RESTART ALL GROUPS WITH TRUE EXPONENTIALS
           IGDEB= 1
           LEXACT= .TRUE.
           IF( IPRT.GT.1 )THEN
              WRITE(IOUT,7000)
           ENDIF
        ENDIF
C
 210  CONTINUE
      IF( IPRT.GT.0 )THEN
         WRITE(IOUT,7001)
      ENDIF
      MESSOU= '*NOT*'
 240  CONTINUE
C
C***  CONVERGENCE REACHED
      IF( IPRT.GT.0 )THEN
         WRITE(IOUT,1060) 'EXTERNAL',MESSOU,IEXTF
         WRITE(IOUT,1061) MAXITR,AKEFF,B2VAL,EEXT
      ENDIF
      RKEFF= AKEFF
      RB2=   B2VAL
      IF( ITYPEC .EQ. 4 )THEN
         DO 326 IG= 1, NGRP
            DIFFB1(IG)= DIFF(IG)
  326    CONTINUE
      ENDIF
      IF( IPRT.GE.2 )THEN
         WRITE(IOUT,1030) (IR,IR=1,NREG)
         DO 161 IG=1,NGRP
            WRITE(IOUT,1090) IG
            WRITE(IOUT,1040) (FLUX(1,IR,IG,3)*AFLNOR,IR=1,NREG)
            DO 166 IA= 2, NFUNL
               WRITE(IOUT,1045) IA,
     >         (FLUX(IA,IR,IG,3)*AFLNOR,IR=1,NREG)
  166       CONTINUE
  161    CONTINUE
      ENDIF
C
C     PROMOTE TO EXTERNAL FLUX TO *FLUXO*
      DO 773 IG= 1, NGRP
         DO 772 IR= 1, NREG
            DO 771 IS= 1, NFUNL
                FLUXO(IR,IS,IG)= FLUX(IS,IR,IG,3)
  771       CONTINUE
  772    CONTINUE
  773 CONTINUE
*
      RETURN
*
  999 FORMAT (/28H SOLVING TRANSPORT EQUATION   //)
 1010 FORMAT (/28H PROPERTIES OF THE GEOMETRY:/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
 1020 FORMAT (1H ,A6,2H: ,1P,10E12.5/(9X,10E12.5))
 1025 FORMAT (1H ,A2,1H(,I2,3H): ,1P,10E12.5/(9X,10E12.5))
 1030 FORMAT (/28H FLUXES AVERAGED           :/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
 1035 FORMAT (/28H CURRENT AVERAGED          :/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
 1040 FORMAT (7H FLUX  ,2H: ,1P,10E12.5/(9X,10E12.5))
 1045 FORMAT (5H CUR ,I2,2H: ,1P,10E12.5/(9X,10E12.5))
 1055 FORMAT (8H SOURCE ,2H: ,1P,10E12.5/(9X,10E12.5))
 1060 FORMAT ( 1X,A8,
     1            13H CONVERGENCE ,A5,14H REACHED AFTER ,I6,
     2            12H ITERATIONS.  )
 1061 FORMAT (/1X,18H TRACKING CALLED= ,I6,6H TIMES ,
     1            13H FINAL KEFF= ,1P,E15.6,5H, B2=,E15.6,
     1            11H PRECISION=,E9.2)
 1067 FORMAT ( 10X,14H  GROUP CONV= ,100I1)
 1070 FORMAT (/21H FINAL VALUE OF KEFF=  ,1P,E15.6 )
 1080 FORMAT (11H ITERATION ,I4)
 1090 FORMAT (/14H ENERGY GROUP ,I6)
 1100 FORMAT (15H FLUX AVERAGED ,2H: ,1P,10E12.5/(9X,10E12.5))
 2064 FORMAT (     10X,3HIN(,I3,6H) FLX:,
     1             5H PRC=,1P,E9.2,
     2             5H TAR=,   E9.2,
     3             7H IGDEB=, I13,
     4             6H ACCE=,0P,F12.5)
 2065 FORMAT (     5H OUT(,I3,6H) EIG:,
     1             5H PRC=,1P,E9.2,
     2             5H TAR=,   E9.2,
     3             6H KEFF=,E13.6,
     4             6H BUCK=,E12.5)
 2066 FORMAT (     5H OUT(,I3,6H) FLX:,
     1             5H PRC=,1P,E9.2,
     2             5H TAR=,   E9.2,
     3             6H FNOR=,   E13.6,
     4             6H ACCE=,0P,F12.5)
 2067 FORMAT (     5H OUT(,I3,6H) FLX:,
     1             28X,
     3             6H FNOR=,1P,E13.6,
     4             6H ACCE=,0P,F12.5)
 7000 FORMAT(1X,'<<< FROM NOW ON, USING EXACT EXP(-X) CALLS >>>')
 7001 FORMAT(1X,3('*** MOC2DR: CONVERGENCE NOT REACHED ***'/))
      END
