*DECK MOC3I1
      SUBROUTINE MOC3I1(IFTRAK, NG, MT, NR, NE, NS, MXS, NT,
     >                  MATALB, WG,     SEGLEN, NRSEG,
     >                  EXPT, EXP2, FLM, FLP, CYM, CYP, NA, SIGANG,
     >                  SR, FLUX, IG0 )
      IMPLICIT  NONE
      INTEGER   NF,MXE
      PARAMETER (NF=1,MXE=64)
      INTEGER   IFTRAK, NG, MT, NR, NS, NE, MXS, NT, NA,
     >                  IG,     IR,     IE,      IT, IG0,
     >          NOIL, MTIL, LINE, IANG, IL, JL, NUMOLD
      INTEGER   NRSEG(MXS), MATALB(-NS:NR)
      REAL      SR(NF,NR,NG), FLUX(NF,NR,NG), SIGANG(NE,-NA:MT,NG),
     >          EXPT(NE,MXS), EXP2(NE,MXS), SEGLEN(MXS),
     >          FLM(NE,MXS), FLP(NE,MXS), CYM(NE,MXS), CYP(NE,MXS)
      REAL      FL0(MXE), CY0(MXE), FL1(MXE), CY1(MXE),
     >          DWEIG(MXE), WG(MXE)
      REAL      ONE, ZERO, TAU, WEIGHT
      PARAMETER ( ONE=1.0, ZERO=0.0 )
C
      DO 1000 IG= IG0,NG
         DO 1100 IR=1,NR
            FLUX (NF,IR,IG)= ZERO
 1100    CONTINUE
 1000 CONTINUE
      DO 4000 IT= 1, NT
           READ(IFTRAK)  IANG,LINE,WEIGHT,
     >       (NRSEG(IL),IL= 1,LINE),(SEGLEN(IL),IL= 1,LINE)
           DO 4100 IE=1,NE
              DWEIG(IE)= WEIGHT*WG(IE)
 4100      CONTINUE
           DO 4200 IG= IG0,NG
              DO 4210 IE=1,NE
                 FL0(IE)= ZERO
                 FL1(IE)= ZERO
                 CY0(IE)= ONE
                 CY1(IE)= ONE
 4210         CONTINUE
              NUMOLD= NRSEG(1)
              DO 4220 IL= 1, LINE
                 NOIL  = NRSEG(IL)
                 MTIL  = MATALB(NOIL)
                 IF( MTIL.LT.0 )THEN
                    IF( NUMOLD.NE.NOIL )THEN
                       DO 4221 IE=1,NE
                          FLM (IE,IL)= ZERO
                          FLP (IE,IL)= ZERO
                          EXP2(IE,IL)= SIGANG(IE,MTIL,IG)
 4221                  CONTINUE
                    ELSE
                       DO 4229 IE=1,NE
                          FLM (IE,IL)= ZERO
                          FLP (IE,IL)= ZERO
                          EXP2(IE,IL)= ZERO
 4229                  CONTINUE
                    ENDIF
                 ELSE
                    DO 4222 IE=1,NE
                       TAU =        SIGANG(IE,MTIL,IG)*SEGLEN(IL)
                       EXP2(IE,IL)= ONE - EXP(-TAU)
                       FLM (IE,IL)= DWEIG(IE)*SR(NF,NOIL,IG)
                       FLP (IE,IL)= DWEIG(IE)*SR(NF,NOIL,IG)
 4222               CONTINUE
                 ENDIF
                 NUMOLD= NOIL
 4220         CONTINUE
              DO 4226 IL= 1, LINE
                 JL= LINE + 1 - IL
                 DO 4225 IE=1,NE
                    FLM(IE,IL) = (FLM(IE,IL) + FL0(IE)) * EXP2(IE,IL)
                    CYM(IE,IL) =               CY0(IE)  * EXP2(IE,IL)
                    FLP(IE,JL) = (FLP(IE,JL) + FL1(IE)) * EXP2(IE,JL)
                    CYP(IE,JL) =               CY1(IE)  * EXP2(IE,JL)
                    FL0(IE)    = FL0(IE) - FLM(IE,IL)
                    CY0(IE)    = CY0(IE) - CYM(IE,IL)
                    FL1(IE)    = FL1(IE) - FLP(IE,JL)
                    CY1(IE)    = CY1(IE) - CYP(IE,JL)
 4225            CONTINUE
 4226         CONTINUE
              DO 4230 IE=1,NE
                 FL0(IE)=  FL0(IE)/(ONE-CY0(IE))
                 FL1(IE)=  FL1(IE)/(ONE-CY1(IE))
 4230         CONTINUE
              DO 4240 IL= 1, LINE
                 NOIL  = NRSEG(IL)
                 IF( NOIL.GT.0 )THEN
                    DO 4241 IE=1,NE
                       FLUX(NF,NOIL,IG)= FLUX(NF,NOIL,IG)
     >                 +(FLM(IE,IL)+FL0(IE)*CYM(IE,IL))
     >                 +(FLP(IE,IL)+FL1(IE)*CYP(IE,IL))
 4241               CONTINUE
                 ENDIF
 4240         CONTINUE
 4200       CONTINUE
 4000 CONTINUE
      RETURN
      END
