      SUBROUTINE LCMLIB(IPLIST)
*
*----------------------------------------------------------------------
*
* LIST THE LCM ENTRIES CONTAINED IN A LINKED LIST OR A XSM FILE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
*------------------------------------ AUTHOR: A. HEBERT ; 25/10/93 ----
*
      PARAMETER (NTYPE=8)
      CHARACTER NAMT*12,NAMLCM*12,MYNAME*12,FIRST*12,CTYPE(NTYPE)*16,
     1 CMEDIU(2)*11
      LOGICAL LCM
      SAVE CTYPE,CMEDIU
      DATA (CTYPE(ITY),ITY=1,NTYPE)/'DIRECTORY','INTEGER','REAL',
     > 'CHARACTER','DOUBLE PRECISION','LOGICAL','COMPLEX','UNDEFINED'/
      DATA (CMEDIU(II),II=1,2)/'LINKED LIST','XSM FILE'/
*
      NAMT=' '
      CALL LCMNXT(IPLIST,NAMT,NAMLCM,MYNAME,LCM)
      IMED=1
      IF(.NOT.LCM) IMED=2
      IF (NAMT.EQ.' ') THEN
         WRITE (6,90) MYNAME,CMEDIU(IMED),NAMLCM
         RETURN
      ENDIF
      FIRST=NAMT
      WRITE(6,100) MYNAME,CMEDIU(IMED),NAMLCM
      ITOT=0
      INMT=0
*
   10 INMT=INMT+1
      CALL LCMLEN(IPLIST,NAMT,ILONG,ITYXSM)
      IF (ITYXSM.EQ.0) THEN
         WRITE (6,110) INMT,NAMT,CTYPE(1)
      ELSE
         WRITE (6,120) INMT,NAMT,ILONG,CTYPE(ITYXSM+1)
         ITOT=ITOT+ILONG
      ENDIF
      CALL LCMNXT(IPLIST,NAMT,NAMLCM,MYNAME,LCM)
      IF (NAMT.EQ.FIRST) GO TO 20
      GO TO 10
*
   20 WRITE(6,130) MYNAME,ITOT
      RETURN
*
   90 FORMAT (/10H LCMLIB: ',A12,31H' IS AN EMPTY DIRECTORY OF THE ,A11,
     1 2H ',A12,2H'.)
  100 FORMAT (//38H LCMLIB: CONTENT OF ACTIVE DIRECTORY ',A12,
     1 9H' OF THE ,A11,2H ',A12,2H'://11H BLOCK NAME,10(1H-),4X,
     2 6HLENGTH,4X,4HTYPE/)
  110 FORMAT (1X,I4,3H  ',A12,1H',14X,A16)
  120 FORMAT (1X,I4,3H  ',A12,1H',I10,4X,A16)
  130 FORMAT (//37H TOTAL NUMBER OF WORDS ON DIRECTORY ',A12,3H' =,
     > I10/)
      END
