*DECK MCI2BN
      SUBROUTINE MCI2BN(NGRP,NANIS,NBN,PHI,D,
     >                  XCTOT,XCABS,XCCAT,XCNUF,XCCHI,BETA,
     >                  A,B,C,EBMX,B2,IPRT )
      IMPLICIT NONE
      INTEGER NGRP,NANIS,NBN
      INTEGER IGRP,IPRT,JGRP,KGRP,ITEX,IER
      REAL    PHI(NGRP),D(NGRP),
     >        XCTOT(NGRP),XCABS(NGRP),XCCAT(NGRP,0:NANIS,NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP)
      DOUBLE PRECISION EPS,B2,SQRTB2,TMP,BIL1,BIL2,ST,ST2,DD,ALPHAS,
     >        DZERO,DONE,REFKEF,A2,ALAM1,ALAM2,ZXC,CAET,ERR3,
     >        A(NGRP,NGRP+1),B(NGRP,NGRP),C(NGRP),BETA(NGRP)
      REAL    ZERO, EBMX
      CHARACTER*4 TYPE
      CHARACTER*131 HSMG
      PARAMETER ( ZERO=0.0, DZERO=0.0D0, DONE=1.0D0 )
      EPS=DBLE(EBMX)
      TYPE= 'B'
      REFKEF= DONE
      BIL1= DZERO
      BIL2= DZERO
      DO 20 IGRP= 1, NGRP
         BIL1=BIL1+(XCNUF(IGRP)/REFKEF-XCABS(IGRP))*PHI(IGRP)
         BIL2=BIL2+D(IGRP)*PHI(IGRP)
   20 CONTINUE
      B2=BIL1/BIL2
      IF(IPRT.GT.1) WRITE(6,420) B2
      ITEX=0
   30 ITEX=ITEX+1
      IF(ITEX.GT.50) CALL XABORT('MCI2BN: UNABLE TO CONVERGE(1).')
      SQRTB2= SQRT(ABS(B2))
      DO 50 IGRP= 1,NGRP
         ST=   XCTOT(IGRP)
         ST2=  ST*ST
         DD=   D(IGRP)
         IF (B2.GT.0.05D0*ST2) THEN
            TMP=SQRTB2/ST
            BETA(IGRP)=(DONE-ATAN(TMP)/TMP)/B2
         ELSE IF ((B2.LT.-0.05D0*ST2).AND.(B2.GE.-0.995D0*ST2)) THEN
            TMP=SQRTB2
            BETA(IGRP)=(DONE-0.5D0*ST*LOG((ST+TMP)/(ST-TMP))/TMP)/B2
         ELSE IF((B2.LE.0.05D0*ST2).AND.(B2.GE.-0.05D0*ST2)) THEN
            TMP=B2/ST2
            BETA(IGRP)=(DONE-3.0D0*TMP*(0.2D0-TMP/7.0D0+TMP*TMP/9.0D0
     >      -TMP*TMP*TMP/11.0D0))/(3.0D0*ST2)
         ELSE
            WRITE(HSMG,'(22HMCI2BN: THE BUCKLING (,1P,E12.4,8H) IS SMA,
     1      9HLLER THAN,E12.4,1H.)') B2,-0.995D0*ST2
            CALL XABORT(HSMG)
         ENDIF
         ALPHAS= DONE-B2*BETA(IGRP)
         DO 40 JGRP=1,NGRP
            A(IGRP,JGRP)= DZERO
            B(IGRP,JGRP)= DZERO
   40    CONTINUE
         A(IGRP,IGRP)=  ST
         A(IGRP,NGRP+1)=  ALPHAS*XCCHI(IGRP)
         DO 50 JGRP= 1, NGRP
            A(IGRP,JGRP)=A(IGRP,JGRP)-ALPHAS*XCCAT(JGRP,0,IGRP)
            B(IGRP,JGRP)=XCCAT(JGRP,0,IGRP)
   50 CONTINUE
      IF( NBN.GE.1 ) THEN
         DO 70 JGRP=1,NGRP
         DO 60 KGRP=1,NGRP
            C(KGRP)=B(KGRP,JGRP)
            B(KGRP,JGRP)=DZERO
   60    CONTINUE
         DO 70 IGRP=1,NGRP
         DO 70 KGRP=1,NGRP
            B(IGRP,JGRP)=B(IGRP,JGRP)+
     >          XCCAT(KGRP,1,IGRP)*C(KGRP)
   70    CONTINUE
         DO 90 IGRP=1,NGRP
         ST=     XCTOT(IGRP)
         DD=     D(IGRP)
         ALPHAS= BETA(IGRP)*ST
         DO 80 JGRP=1,NGRP
            A(IGRP,JGRP)=A(IGRP,JGRP)+ALPHAS*B(IGRP,JGRP)
   80    CONTINUE
         DO 90 JGRP= 1, NGRP
            A(IGRP,NGRP+1)=A(IGRP,NGRP+1)
     >          -ALPHAS*XCCAT(JGRP,1,IGRP)*XCCHI(JGRP)
            A(IGRP,JGRP)=A(IGRP,JGRP)
     >          -ALPHAS*XCCAT(JGRP,1,IGRP)*XCTOT(JGRP)
   90    CONTINUE
      ENDIF
      CALL B1SOL(NGRP,A,IER)
      IF(IER.NE.0) CALL XABORT('B1DIF: SINGULAR MATRIX(1).')
      ALAM1= DZERO
      CAET=  DZERO
      DO 130 IGRP= 1, NGRP
         ALAM1= ALAM1+XCNUF(IGRP)*A(IGRP,NGRP+1)
         CAET=  CAET+XCABS(IGRP)*A(IGRP,NGRP+1)
  130 CONTINUE
      IF(IPRT.GT.1) WRITE (6,430) ITEX,ALAM1
      IF(TYPE.EQ.'K') THEN
         DO 140 IGRP=1,NGRP
  140    PHI(IGRP)=A(IGRP,NGRP+1)/ALAM1
      ELSE IF(TYPE.EQ.'B') THEN
*        COMPUTE THE EXTRAPOLATED BUCKLING.
         B2=B2*(ALAM1/REFKEF-CAET)/(DONE-CAET)
*        CHECK THE CONVERGENCE.
         BIL1= DZERO
         BIL2= DZERO
         DO 150 IGRP=1,NGRP
         ST2= XCTOT(IGRP)**2
         IF(B2.LT.-0.995D0*ST2) THEN
            WRITE(HSMG,'(35HMCI2BN: THE EXTRAPOLATED BUCKLING (,
     >      1P,E12.4,
     >      17H) IS SMALLER THAN,E12.4,13H AT ITERATION,I5,1H.)') B2,
     >      -0.995D0*ST2,ITEX
            CALL XABORT(HSMG)
         ENDIF
         BIL1=MAX(BIL1,ABS(A(IGRP,NGRP+1)/ALAM1))
         BIL2=MAX(BIL2,ABS(PHI(IGRP)-A(IGRP,NGRP+1)/ALAM1))
  150    PHI(IGRP)=A(IGRP,NGRP+1)/ALAM1
         ERR3=ABS(REFKEF-ALAM1)
         IF((BIL2.GE.10*EPS*BIL1).OR.(ERR3.GE.EPS)) GO TO 30
      ENDIF
C
         SQRTB2= SQRT(ABS(B2))
         DO 325 IGRP=1,NGRP
         ST=   XCTOT(IGRP)
         ST2=  ST*ST
         DD=   D(IGRP)
         IF (B2.GT.0.05D0*ST2) THEN
            TMP=SQRTB2/ST
            BETA(IGRP)=(DONE-ATAN(TMP)/TMP)/B2
         ELSE IF ((B2.LT.-0.05D0*ST2).AND.(B2.GE.-0.995D0*ST2)) THEN
            TMP=SQRTB2
            BETA(IGRP)=(DONE-0.5D0*ST*LOG((ST+TMP)/(ST-TMP))/TMP)/B2
         ELSE IF((B2.LE.0.05D0*ST2).AND.(B2.GE.-0.05D0*ST2)) THEN
            TMP=B2/ST2
            BETA(IGRP)=(DONE-3.0D0*TMP*(0.2D0-TMP/7.0D0+TMP*TMP/9.0D0
     >      -TMP*TMP*TMP/11.0D0))/(3.0D0*ST2)
         ELSE
            WRITE(HSMG,'(22HMCI2BN: THE BUCKLING (,1P,E12.4,8H) IS SMA,
     1      9HLLER THAN,E12.4,1H.)') B2,-0.995D0*ST2
            CALL XABORT(HSMG)
         ENDIF
         ALPHAS= BETA(IGRP)*ST/(DONE-B2*BETA(IGRP))
         DO 310 JGRP=1,NGRP
  310    A(IGRP,JGRP)= DZERO
         A(IGRP,IGRP)= DONE
         A(IGRP,NGRP+1)= ALPHAS
         IF( NBN.GE.1 )THEN
            DO 320 JGRP= 1, NGRP
               A(IGRP,JGRP)=A(IGRP,JGRP)
     >          -ALPHAS*XCCAT(JGRP,1,IGRP)*PHI(JGRP)/PHI(IGRP)
  320       CONTINUE
         ENDIF
  325    CONTINUE
         CALL B1SOL(NGRP,A,IER)
         IF(IER.NE.0) CALL XABORT('MCI2BN: SINGULAR MATRIX(2).')
         DO 330 IGRP=1,NGRP
            D(IGRP)= A(IGRP,NGRP+1)
  330    CONTINUE
C
      A2=   DZERO
      CAET= DZERO
      ZXC=  DZERO
      DO 350 IGRP=1,NGRP
         A2=   A2+D(IGRP)*PHI(IGRP)
         CAET= CAET+XCABS(IGRP)*PHI(IGRP)
         ZXC=  ZXC+XCNUF(IGRP)*PHI(IGRP)/REFKEF
  350 CONTINUE
      A2=A2/CAET
      CAET=ZXC/CAET
      ALAM2=CAET/(DONE+A2*B2)
      IF(TYPE.EQ.'L') ALAM1=ALAM2
      IF(IPRT.GT.1) THEN
         WRITE (6,450) ITEX,B2,ALAM1,ALAM2,CAET,A2
      ENDIF
      RETURN
*
  400 FORMAT(/43H MCI2BN: DIFFUSION COEFFICIENT CALCULATION.)
  410 FORMAT(/21H MCI2BN: SOLUTION OF ,A4,21H EQUATIONS WITH TYPE ,A4)
  415 FORMAT(48H MCI2BN: THE INITIAL BUCKLING WAS INCREASED FROM,1P,
     1 E13.5,3H TO,E13.5)
  420 FORMAT(27H MCI2BN: INITIAL BUCKLING =,1P,E13.5)
  430 FORMAT(34H MCI2BN: K-EFFECTIVE ITERATION NO.,I3,13H. K-EFFECTIVE,
     1 2H =,F10.6)
  450 FORMAT(8X,22HNUMBER OF ITERATIONS =,I3/8X,10HBUCKLING =,1P,E13.5,
     1 0P/8X,13HK-EFFECTIVE =,F10.6,3H  (,F10.6,2H )/8X,12HK-INFINITE =,
     2 F10.6/8X,16HMIGRATION AREA =,1P,E13.5/)
      END
      
     
