*DECK MCI2DR
C****************************************************************
      SUBROUTINE MCI2DR(IPFLUX,IFTRAK,
     +              NGRP,NREG,NSOUT, NANIS,NMAT,MXSEG, NTRK,
     +              NPHI, NMOD, KEYANI,
     +              MATCOD,MATALB,VOL,PHIANG,DENSTY,
     +              SEGLEN,NRSEG,EXP2, FLM,FLP,CYP,CYM, VOID,
     +              INVVOL, SIGANG,SANINV,ALBEDO,
     +              XSTOT,XSTRC,XSDIA,XSCAT,
     +              NIFIS,XSNUF,XSCHI,YTDB2,YSDB2,ITRB,
     +              SOURCE,Q,FLUX,FLUXO,FLUX1,FLUXW,FLXMPI,
     +              MASQ,CMASQ,LEAKSW,LREBAL,ICAC,
     +              NINTMX,AIEPSF,NEXTMX,AEEPSF,
     +              IPRT,ITYPEC,ILEAK,NL,NBN,RKEFF,RB2,
     +              SOURCO,REBAL,CPTL,CPTA,
     +              A14,PHI,XCTOT,XCTR,XCS0,
     +              XCCAT,XCNUF,XCCHI,XCABS,
     +              DIFF,DB2,BETA,AST,BST,CST,
     +              CUR, SURF, ITCRMX,ATCRMX,
     +              FACN, FCSUR, FACF, FL, INDSUR, 
     +              LJACC, LETAB, L2LNG, MAXSCR,LITLM)
*
      IMPLICIT NONE
*
      INTEGER NGRP,NREG,NANIS,NMAT, MXSEG, 
     >        NSOUT, ICAC,
     >        IPRT,ITYPEC,IFTRAK,NTRK,NPHI,NMOD,
     >        NL,NBN,IPRTT,IPFLUX,ITRB,ITCRMX,
     >        CPTL,CPTA,CTOT,CPTM,MAXITR,MAXSCR
      INTEGER MATCOD(NREG),MATALB(-NSOUT:NREG),NRSEG(MXSEG),
     >        MASQ(NGRP),CMASQ(NGRP),KEYANI(1)
      INTEGER IR,IG,JG,IA,IT,JT,JT2,IS,ITERF
      INTEGER ISTACK,FCACCE
      INTEGER NEXTMX,NINTMX,IEXTF,ILEAK,NIFIS,VOID(MXSEG)
      REAL    SEGLEN(MXSEG), ALBEDO(6), RKEFF, RB2
      REAL    SIGANG(NGRP,-6:NREG),SANINV(NGRP,-6:NREG)
      REAL    PNL,
     >        FLM(MXSEG),
     >        FLP(MXSEG),CYM(MXSEG),CYP(MXSEG),
     >        XSTOT(0:NMAT,NGRP),XSTRC(0:NMAT,NGRP),XSDIA(0:NMAT,NGRP),
     >        XSCAT(NGRP,0:NMAT,0:NANIS,NGRP),
     >        XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP),
     >        PHIANG(3,NPHI),DENSTY(NPHI),
     >        Q(NREG,NMOD,NGRP)
      REAL    YSDB2(NGRP,0:NMAT,0:NANIS),YTDB2(0:NMAT,NGRP)
      REAL    INVVOL(-NSOUT:NREG)
      REAL    PHI(NGRP),DIFF(NGRP),DB2(NGRP),A14(0:NMAT,NIFIS),
     >        XCTOT(NGRP),XCABS(NGRP),XCCAT(NGRP,0:NANIS,NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP),XCTR(NGRP),XCS0(NGRP)
      REAL    VOL(NREG),
     >        FLUXW((1+NSOUT+NREG)*NGRP),
     >        FLXMPI((1+NSOUT+NREG)*NGRP),
     >        REBAL(NGRP,NGRP+1),
     >        EINN,EEXT,FINN,FEXT,GINN,GEXT,EIMX,EEMX,EBMX,MU,
     >        AIEPSF,AEEPSF,FACT,ONE,ZERO,EEXF,EFMX,ATCRMX, EPSLEN,
     >        ECRMX
      DOUBLE PRECISION
     >        FLUX(NGRP,-NSOUT:NREG,3),
     >        FLUX1(NGRP,NREG),
     >        FLUXO(-NSOUT:NREG,NGRP),
     >        SOURCE(NGRP,NREG),
     >        SOURCO(NGRP,NREG),
     >        CUR(NGRP,-NSOUT:-1),
     >        FACN(NGRP,NREG), 
     >        FCSUR(NGRP,-NSOUT:-1),
     >        FACF(NREG,NGRP)
      INTEGER INDSUR(-NSOUT:-1), MAXCON, NINT
C
      DOUBLE PRECISION FL(NGRP,2), EXP2(MXSEG*NGRP)
      DOUBLE PRECISION AFLNOR, FISOUR, AKEFF, AKEFFO, OLDBIL,
     >        B2VAL, B2VALO, BFLNOR, CAET,DXN,DXG
      DOUBLE PRECISION DONE, DZERO
      DOUBLE PRECISION AST(NGRP,NGRP+1),BST(NGRP,NGRP),CST(NGRP),
     >        BETA(NGRP)
      LOGICAL LEAKSW,LREBAL,LSURF,LVOID, 
     >     LPNL, LJACC, LITLM, LB, LETAB, L2LNG
      CHARACTER*8 NAMFLX
      CHARACTER*5 MESSIN, MESSOU
      REAL    SURF(-NSOUT:-1)
      REAL    XTEMP
      PARAMETER ( ZERO=0.0, ONE=1.0, DZERO=0.0D0, DONE=1.0D0, 
     >            EPSLEN=1.0E-4 )
C
      INTEGER ILIB, IACC
      FCACCE= 0
      ECRMX= 1.E-2
      EINN= 1.0
      WRITE(6,999)
      IF( ITYPEC.EQ.3.AND.ILEAK.EQ.2 )THEN
         LPNL=.TRUE.
      ELSE
         LPNL=.FALSE.
      ENDIF
      EEXT=1.0
      LSURF=.FALSE.
      LVOID=.FALSE.
      INVVOL(0)=ZERO
      DO 1001 IR=1,NREG
         INVVOL(IR)= ONE/VOL(IR)
 1001 CONTINUE
C
C*    FACTOR (2*IA+1) INCLUDED IN XSCAT
      DO 31 JG=1,NGRP
      DO 21 IA=1,NANIS
      DO 11 IR=1,NMAT
      DO  1 IG=1,NGRP
         XSCAT(IG,IR,IA,JG)= REAL(2*IA+1)*XSCAT(IG,IR,IA,JG)
    1 CONTINUE
   11 CONTINUE
   21 CONTINUE
   31 CONTINUE     
C     
C     WE COULD PERFORM TRANSPORT CORRECTION   
      DO 1003 IG=1,NGRP
      DO 1002 IR=0,NMAT
         YTDB2(IR,IG)= XSTRC(IR,IG)
         DO 1005 IA= 0, NANIS
            YSDB2(IG,IR,IA)= XSCAT(IG,IR,IA,IG)
 1005    CONTINUE
         YSDB2(IG,IR,0)= XSDIA(IR,IG)
 1002 CONTINUE
         DB2(IG)= ZERO
         XCTOT(IG)= ONE
 1003 CONTINUE
C      STOP
C
C     FILL-UP FOR SIGANG
      DO 30 JG=1,NGRP
         DO 10 IR=-6,NREG
            IF(IR.LE.0) THEN
               SIGANG(JG,IR) = ALBEDO(-IR)
               SANINV(JG,IR) = ZERO
            ELSE
               SIGANG(JG,IR) = XSTRC(MATCOD(IR),JG) 
               IF( SIGANG(JG,IR).EQ.ZERO )THEN
                  SANINV(JG,IR)= ONE
                  LVOID=.TRUE.
               ELSE
                  SANINV(JG,IR)= ONE/SIGANG(JG,IR)
               ENDIF
            ENDIF
   10     CONTINUE
   30 CONTINUE
C
C     FLUX INITIALISATION
      AKEFFO= DZERO
      DO 22 IG= 1, NGRP
         WRITE(NAMFLX,'(4HFLUX,I3,1X)') IG
         CALL LCMGET(IPFLUX,NAMFLX,FLUXW)
         DO  2 IS=-NSOUT, -1
            XTEMP= FLUXW(NREG-IS+1)
CD            write(*,*)'XTEMP', XTEMP
c            IF( XTEMP.LE.EPSLEN ) THEN
c                XTEMP= FLUXW(INDSUR(IS))*SURF(IS)
c            ENDIF
c            XTEMP= FLUXW(INDSUR(IS))*SURF(IS)
            FLUXO(IS,IG)  = DBLE( XTEMP )
            CUR(IG,IS)    = DZERO
            DO 3 ISTACK= 1, 3
              FLUX(IG,IS,ISTACK) = FLUXO(IS,IG)
    3       CONTINUE
    2    CONTINUE
         DO 12 IR= 1, NREG
            FLUXO(IR,IG)  = DBLE( FLUXW(IR) )
            FLUX1(IG,IR)  = DZERO
            DO 4 ISTACK= 1, 3
              FLUX(IG,IR,ISTACK) = FLUXO(IR,IG)
    4       CONTINUE
   12    CONTINUE
         MASQ(IG) = 0
   22 CONTINUE
C     
C     COMPUTE FIRST K-EFFECTIVE
      IF( ITYPEC.EQ.1.OR.ITYPEC.EQ.3 )THEN
         OLDBIL= DZERO
         CALL MCI2KF(ITYPEC,NGRP,NREG,NANIS,NMAT,NSOUT,LEAKSW,OLDBIL,
     >               MATCOD,VOL,FLUX(1,-NSOUT,2),
     >               XSTOT,XSCAT,NIFIS,XSNUF,XSCHI,DB2,
     >               AKEFF,AFLNOR)
         AKEFFO= AKEFF
      ELSE
         AKEFFO= DONE
         AKEFF=  DONE
         AFLNOR= DONE
      ENDIF
      B2VAL=  DZERO
      B2VALO= DZERO
C
      CTOT = CPTA+CPTL 
      IF( CPTA.EQ.0 )THEN
         CPTM=CTOT+1
      ELSE
         CPTM= CPTL
      ENDIF
      MAXITR= 0
      EIMX=   AIEPSF
      EFMX=   AIEPSF
      EEMX=   AEEPSF
Cwu      FACT=   0.1
      FACT=   1.0
      MESSOU= '     '
      WRITE(6,1065) 0,AKEFFO,B2VALO,1.E30
C
C***  OUTER LOOP
 2000 CONTINUE
      CALL MCIRWD( IFTRAK )
      DO 210 IT=1,NEXTMX
      MAXCON= 1
      LB= .TRUE.
      ILIB= -1
      JT2 = 0
      IACC= 0
C
C***  Surface updating according to islip
C     -----------------------------------
C
C      CONDITION IMPOSSIBLE
C        FISSION SOURCE CALCULATION 
         DO 91 IR= 1,NREG
           IF( ITYPEC.EQ.1.OR.ITYPEC.EQ.3 )THEN
              DO 89 IG= 1,NGRP
                 MASQ(IG) = 0
                 SOURCO(IG,IR)= DZERO
   89         CONTINUE
              DO 92 IS= 1,NIFIS
              FISOUR= DZERO
              DO 93 IG= 1, NGRP
                 FISOUR= FISOUR+XSNUF(MATCOD(IR),IS,IG)*FLUXO(IR,IG)
   93         CONTINUE 
              FISOUR= FISOUR*AFLNOR
              DO 90 IG= 1,NGRP
                 SOURCO(IG,IR)= SOURCO(IG,IR)+
     >                            XSCHI(MATCOD(IR),IS,IG)*FISOUR
   90         CONTINUE
   92         CONTINUE
           ELSE
              DO 19 IG=1,NGRP
                SOURCO(IG,IR)= XSNUF(MATCOD(IR),1,IG)
   19         CONTINUE
           ENDIF
   91    CONTINUE
C
         MESSIN='     '
C
C***    INNER LOOP
        IF( LITLM ) THEN
          NINT= MIN(IT, NINTMX)
        ELSE
          NINT= NINTMX
        ENDIF
         IF( LREBAL )THEN
            CALL MCI2BL( NGRP, NSOUT, NREG, FLUX(1,-NSOUT,2),
     >                   SOURCO, SOURCE,
     >                   VOL, MASQ, MATALB, ALBEDO, 
     >                   MATCOD, NMAT, NANIS, YTDB2, XSCAT, YSDB2, 
     >                   XSTRC, REBAL, IPRT)
         ENDIF      
        DO 500 JT= 1, NINT
C         FREE ITERATIONS
C         NORMALIZE FLUXES AND COMPUTE SOURCES
          JT2 = JT2 + 1
          DO 45 IR= 1,NREG
          DO 45 IG= MAXCON,NGRP
               SOURCE(IG,IR)= SOURCO(IG,IR)
               DO 32 JG= 1,IG-1
                  SOURCE(IG,IR)= SOURCE(IG,IR)+ 
     >               XSCAT(JG,MATCOD(IR),KEYANI(1),IG)
     >               *FLUX(JG,IR,2)               
   32          CONTINUE
               SOURCE(IG,IR)= SOURCE(IG,IR)
     >            +YSDB2(IG,MATCOD(IR),KEYANI(1))
     >            *FLUX(IG,IR,2)
               DO 34 JG= IG+1,NGRP
                  SOURCE(IG,IR)= SOURCE(IG,IR)+ 
     >               XSCAT(JG,MATCOD(IR),KEYANI(1),IG)
     >               *FLUX(JG,IR,2)               
   34          CONTINUE
               IF( XSTRC(MATCOD(IR),IG).NE.ZERO )THEN
                  SOURCE(IG,IR) = SOURCE(IG,IR) 
     >                            / XSTRC(MATCOD(IR),IG)
               ENDIF
               IF(SOURCE(IG,IR).LT.ZERO) THEN
                 SOURCE(IG,IR)=ZERO
               ENDIF
   45    CONTINUE
C
        IF( ITYPEC.EQ.3.AND.ILEAK.EQ.2 )THEN
          DO 5 IG=1,NGRP
            IF( MASQ(IG).EQ.0 )THEN 
              DXN= DZERO
              DXG= DZERO
              DO 6 IR=1,NREG
                DXN= DXN + XSTRC(MATCOD(IR),IG)
     >                  *FLUX(IG,IR,2)*VOL(IR)
                DXG= DXG + FLUX(IG,IR,2)*VOL(IR)
    6         CONTINUE  
              PNL= REAL( DXN/(DXN+DBLE(DB2(IG))*DXG) )          
              DO 7 IR=1,NREG
              SOURCE(IG,IR)= SOURCE(IG,IR)*PNL
    7         CONTINUE  
              XCTOT(IG)=PNL
            ENDIF
    5     CONTINUE
        ENDIF
        LSURF=.TRUE.
C       FLUX COMPUTATION
        IF( LVOID ) THEN
           WRITE(*,*) 'MCI2DR: Void regions existe.'
           CALL MCI2F0( IFTRAK, NGRP, NL, NREG, NSOUT, MXSEG, NTRK, 
     >                  NPHI, NMOD, SURF,
     >                  MATALB, ALBEDO, INVVOL, SEGLEN, NRSEG, 
     >                  EXP2, FLM, FLP, VOID,
     >                  SIGANG, SANINV, 
     >                  SOURCE, FLUX(1,-NSOUT,3), CUR, MASQ, 
     >                  IPRT)
        ELSE
           FCACCE= 3
C
C          Acceleration de J+-
           CALL MCI2FD( IFTRAK, NGRP  , NREG  , NSOUT , MXSEG , NTRK  , 
     2                  NMAT  , NANIS , MATALB, NRSEG , MASQ  , INDSUR,  
     3                  KEYANI, SURF  , ALBEDO, INVVOL, SEGLEN, EXP2  , 
     4                  SIGANG, SANINV, XSCAT , XSDIA , SOURCE, SOURCO, 
     5                  FLUX(1,-NSOUT,3) , FLUX1,  
     >                                  CUR   , FL    , FACN  , FACF  , 
     6                  FCSUR , XCTOT , EINN  , MAXCON, LETAB , L2LNG , 
     7                  MAXSCR  , IPRT  )
        ENDIF
        MAXITR= MAXITR + 1
c
         IF( LREBAL )THEN
            CALL MCI2BL( NGRP, NSOUT, NREG, FLUX(1,-NSOUT,3),
     >                   SOURCO, SOURCE,
     >                   VOL, MASQ, MATALB, ALBEDO, 
     >                   MATCOD, NMAT, NANIS, YTDB2, XSCAT, YSDB2, 
     >                   XSTRC, REBAL, IPRT)
         ENDIF
C
C         IF( MOD(JT2-1,CTOT).GE.CPTM )THEN
         IF( ILIB.GE.CPTL )THEN
C
C           ACCELERATED ITERATIONS
            LB= .FALSE.
            CALL MCI2AC( NGRP  , NSOUT , NREG, FLUX, MASQ, MU, 
     >                   FCACCE, MAXCON, IPRT )
            IF( MU.EQ.ONE ) THEN
              IF( IACC.GT.0 ) THEN
                ILIB= 1
                IACC= 0
              ELSE
                ILIB= ILIB + 1
              ENDIF
            ELSE
              IACC= IACC + 1
              IF( IACC.GE.CPTA )THEN
                IACC= 0
                ILIB= 0
              ENDIF
            ENDIF
         ELSE
            ILIB= ILIB + 1
            MU= ONE
            LB= .TRUE.
         ENDIF
C
C
         EINN= ZERO
         DO 220 IG= 1, NGRP
           IF( MASQ(IG).EQ.0 )THEN 
           GINN= ZERO
           FINN= ZERO
           DO 221 IR= -NSOUT, -1
           DO 221 ISTACK= 1, 2
              FLUX(IG,IR,ISTACK)= FLUX(IG,IR,ISTACK+1)
  221      CONTINUE
           DO 222 IR= 1, NREG
              GINN= MAX(GINN,
     >              REAL(ABS(FLUX(IG,IR,2)-FLUX(IG,IR,3))))
              FINN= MAX(FINN,REAL(ABS(FLUX(IG,IR,3))))
              DO 223 ISTACK= 1, 2
                FLUX(IG,IR,ISTACK)= FLUX(IG,IR,ISTACK+1)
  223         CONTINUE
  222      CONTINUE
           GINN= GINN/FINN
C           IF( GINN.LT.EIMX ) THEN
C             MASQ(IG) = 1
C           ENDIF
           IF( GINN.LT.EIMX .and. IG.EQ.MAXCON ) THEN
             MASQ(IG) = 1
             MAXCON= MAXCON + 1
           ENDIF
           EINN=MAX(EINN,GINN)
           ENDIF
  220    CONTINUE
        CALL MCIRWD( IFTRAK )
        ITERF= JT
        WRITE(6,1066) JT,MU,EINN
        IF( IPRT.GT.3 )THEN
           WRITE(6,1067) (MASQ(IG),IG=1,NGRP)
        ENDIF
        IF( EINN.LT.EIMX ) THEN
           GO TO 750
        ENDIF
  500  CONTINUE
C***    INNER LOOP
C
       MESSIN='*NOT*'
  750  CONTINUE
       WRITE(6,1060) 'INTERNAL',MESSIN,ITERF
        IF( ITYPEC.EQ.3 )THEN
C
C        HOMOGENIZE CELL
         CALL MCI2HM(NGRP,NREG,NANIS,NMAT,NSOUT,
     >                  KEYANI,MATCOD,VOL,FLUX(1,-NSOUT,3),ITRB,
     >                  XSTOT,XSTRC,XSDIA,XSCAT,NIFIS,XSNUF,XSCHI,
     >                  A14,PHI,
     >                  XCTOT,XCTR,XCS0,XCCAT,XCNUF,XCCHI,XCABS,IPRT )
         IF( IT.GE.1 )THEN
         IF( IT.EQ.1 )THEN
C
C         INITIALIZE DIFFUSION COEFFICIENTS
          DO 1004 IG= 1, NGRP
             DIFF(IG)= 1./(3.*XCTOT(IG))
 1004     CONTINUE
          EEXT=10.*EEMX
          AKEFFO= AKEFF
         ENDIF
C        ELSE
C
C         SOLVE BN EQUATION ON THE HOMOGENIZED CELL
          EBMX= 1.E-6
          CALL MCI2BN(NGRP,NANIS,NBN,PHI,DIFF,
     >             XCTOT,XCABS,XCCAT,XCNUF,XCCHI,BETA,
     >             AST,BST,CST,EBMX,B2VAL,IPRT )
C NORMALIZE FLUX(1,1,3)
          DO 830 IG=1,NGRP
          CAET= DZERO
          DO 810 IR=1,NREG
            CAET= CAET + FLUX(IG,IR,3)*VOL(IR)
  810     CONTINUE
          CAET=PHI(IG)/CAET
          DO 820 IR=-NSOUT,NREG
            FLUX(IG,IR,3)= FLUX(IG,IR,3)*CAET
  820     CONTINUE
  830     CONTINUE
C
          DO 335 IG=1,NGRP
             DB2(IG)= DIFF(IG)*B2VAL
  335     CONTINUE
          IF( ILEAK.EQ.2 )THEN
             DO 336 IG=1,NGRP
                XCTOT(IG)=  XCTR(IG)
     >                    /(XCTR(IG)+DB2(IG))
  336        CONTINUE
             DO 433 JG=1,NGRP
             DO 433 IR=0,NMAT
                YTDB2(IR,JG)= XSTRC(IR,JG)+DB2(JG)
  433        CONTINUE
          ELSEIF( ILEAK.EQ.3 )THEN
             DO 334 IG=1,NGRP
             DO 334 IR=0,NMAT
                YSDB2(IG,IR,0)= XSDIA(IR,IG)-DB2(IG)
  334        CONTINUE
          ELSE
             CALL XABORT('MCI2DR: OTHER LEAKAGE OPTIONS NOT CODED')
          ENDIF
          IF( B2VAL.EQ.DZERO )THEN
             BFLNOR= DONE
          ELSE
             BFLNOR= DONE/ABS(B2VAL)
          ENDIF
          EEXT= ABS(B2VAL-B2VALO)*BFLNOR
          B2VALO= B2VAL
         ENDIF
        ENDIF
        IEXTF= IT
        IF( ITYPEC.GT.0 )THEN
           CALL MCI2KF(ITYPEC,NGRP,NREG,NANIS,NMAT,NSOUT,LEAKSW,OLDBIL,
     >                 MATCOD,VOL,FLUX(1,-NSOUT,3),
     >                 XSTOT,XSCAT,NIFIS,XSNUF,XSCHI,DB2,
     >                 AKEFF,AFLNOR)
           EEXT= ABS(AKEFF-AKEFFO)/AKEFF
        ELSE
           EEXT= DZERO
        ENDIF
        IF( EEXT.LT.EEMX )THEN
C
C        COMPARE FLUX FOR OUTER ITERATIONS   
         EEXF=1.0E-6
         DO 322 IG= 1, NGRP
          GEXT= ZERO
          FEXT= ZERO
           DO 521 IR= -NSOUT, -1
              FLUXO(IR,IG)= FLUX(IG,IR,3)
  521      CONTINUE
          DO 321 IR= 1, NREG
             GEXT= MAX(GEXT,REAL(ABS(FLUXO(IR,IG)-FLUX(IG,IR,3))))
             FEXT= MAX(FEXT,REAL(ABS(FLUX(IG,IR,3))))
             FLUXO(IR,IG)= FLUX(IG,IR,3)
  321     CONTINUE
          GEXT= GEXT/FEXT
          EEXF= MAX(EEXF,GEXT)
  322    CONTINUE
         WRITE(6,1064) IT,AKEFF,B2VAL,EEXF
        ELSE
         EEXF=1.0
         DO 325 IG= 1, NGRP
           DO 421 IR= -NSOUT, -1
              FLUXO(IR,IG)= FLUX(IG,IR,3)
  421      CONTINUE
          DO 324 IR= 1, NREG
             FLUXO(IR,IG)= FLUX(IG,IR,3)
  324     CONTINUE
  325    CONTINUE
         WRITE(6,1065) IT,AKEFF,B2VAL,EEXT
        ENDIF
C
C       UPDATE KEFF
        AKEFFO= AKEFF
        IF( EEXF.LT.EFMX ) GO TO 240
        EIMX = EIMX*FACT
        IF( EIMX.LT.EEMX ) EIMX = EEMX
C
 210  CONTINUE
      WRITE(6,*) '*** MCI2DR: CONVERGENCE NOT REACHED ***'
      WRITE(6,*) '*** MCI2DR: CONVERGENCE NOT REACHED ***'
      WRITE(6,*) '*** MCI2DR: CONVERGENCE NOT REACHED ***'
      MESSOU= '*NOT*'
 240  CONTINUE
C
C***  CONVERGENCE REACHED
      WRITE(6,1060) 'EXTERNAL',MESSOU,IEXTF
      WRITE(6,1061) MAXITR,AKEFF,B2VAL,EEXT
      RKEFF= AKEFF
      RB2=   B2VAL
      IF( IPRT.GE.2 )THEN
          IF( ITYPEC.EQ.1.OR.ITYPEC.EQ.3 )THEN
             WRITE(6,1030) (IR,IR=1,NREG)
             DO 161 IG=1,NGRP
                WRITE(6,1090) IG
                WRITE(6,1040) (FLUXO(IR,IG)*AFLNOR,IR=1,NREG)
                WRITE(6,1045) (FLUXO(IS,IG)*AFLNOR,IS=-NSOUT,-1)
  161        CONTINUE
             IPRTT= 2
             CALL MCI2HM(NGRP,NREG,NANIS,NMAT,NSOUT,
     >                  KEYANI,MATCOD,VOL,FLUX(1,-NSOUT,3),0,
     >                  XSTOT,XSTRC,XSDIA,XSCAT,NIFIS,XSNUF,XSCHI,
     >                  A14,PHI,
     >                  XCTOT,XCTR,XCS0,XCCAT,XCNUF,XCCHI,XCABS,IPRTT )
  
          ELSE
             WRITE(6,1030) (IR,IR=1,NREG)
             DO 87 IG=1,NGRP
                WRITE(6,1090) IG
                WRITE(6,1040) (FLUXO(IR,IG),IR=1,NREG)
                WRITE(6,1045) (FLUXO(IS,IG),IS=-NSOUT,-1)
  87         CONTINUE
          ENDIF
      ENDIF
*
      RETURN
*
  999 FORMAT (/28H SOLVING TRANSPORT EQUATION   //)
 1010 FORMAT (/28H PROPERTIES OF THE GEOMETRY:/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
 1020 FORMAT (1H ,A6,2H: ,1P,10E12.5/(9X,10E12.5))
 1025 FORMAT (1H ,A2,1H(,I2,3H): ,1P,10E12.5/(9X,10E12.5))
 1030 FORMAT (/28H FLUXES AVERAGED           :/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
 1035 FORMAT (/28H CURRENT AVERAGED          :/
     1 (9X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,
     2 I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,2H/=,I4,:,6X,
     3 2H/=,I4))
 1040 FORMAT (7H FLUX  ,2H: ,1P,10E12.5/(9X,10E12.5))
 1045 FORMAT (13H CUR-SURFACE ,2H: ,1P,10E12.5/(9X,10E12.5))
 1055 FORMAT (8H SOURCE ,2H: ,1P,10E12.5/(9X,10E12.5))
 1060 FORMAT ( 1X,A8,
     1            13H CONVERGENCE ,A5,14H REACHED AFTER ,I6,
     2            12H ITERATIONS.  )
 1061 FORMAT (/1X,18H TRACKING CALLED= ,I6,6H TIMES ,
     1            13H FINAL KEFF= ,1P,E15.6,5H, B2=,E15.6,
     1            11H PRECISION=,E9.2)
 1064 FORMAT (/1X,7H OUTER(,I6,8H), KEFF= ,1P,E15.6,5H, B2=,E15.6,
     1            11H PRECISION=,E9.2,1H*)
 1065 FORMAT (/1X,7H OUTER(,I6,8H), KEFF= ,1P,E15.6,5H, B2=,E15.6,
     1            11H PRECISION=,E9.2)
 1066 FORMAT (  3X,7H INNER(,I6,3H): ,
     1             15H ACCELERATION= ,F9.6,
     2             12H PRECISION= ,1P,E9.2)
 1067 FORMAT ( 10X,14H  GROUP CONV= ,100I1)
 1070 FORMAT (/21H FINAL VALUE OF KEFF=  ,1P,E15.6 )
 1080 FORMAT (11H ITERATION ,I4)
 1090 FORMAT (/14H ENERGY GROUP ,I6)
 1100 FORMAT (15H FLUX AVERAGED ,2H: ,1P,10E12.5/(9X,10E12.5))
      END
