*DECK MOC2AC
      SUBROUTINE MOC2AC( NG, NF, NR, FLUX, AKEEP, IG0, MU )
C
      IMPLICIT  NONE
      INTEGER   NR, NF, NG, IG0, IG, IF, IR
      REAL      FLUX(NF,NR,NG,3), MU
      DOUBLE PRECISION  AKEEP(3)
      DOUBLE PRECISION  DMU, R1, R2
      DOUBLE PRECISION  DONE, DZERO, NOM, DENOM
      PARAMETER ( DONE=1.0D0, DZERO=0.0D0 )
C
C     MU CALCULATION
      NOM   = DZERO
      DENOM = DZERO
      DO  3 IG= IG0,NG
          DO  2 IR=1,NR
          DO  1 IF=1,NF
             R1 = FLUX(IF,IR,IG,2) - FLUX(IF,IR,IG,1)
             R2 = FLUX(IF,IR,IG,3) - FLUX(IF,IR,IG,2)
             NOM = NOM + R1*(R2-R1)
             DENOM = DENOM + (R2-R1)*(R2-R1)
    1     CONTINUE
    2     CONTINUE
    3 CONTINUE
C
      DMU = - NOM / DENOM
      MU  = REAL(DMU)
      IF( DMU.GT.DZERO )THEN
       DO  13 IG= IG0,NG
          DO  12 IR=1,NR
          DO  11 IF=1,NF
C
C           ACCELERATED VALUES FOR PHI(2) ET PHI(3)
            FLUX(IF,IR,IG,3) = FLUX(IF,IR,IG,2) + DMU *
     >        (FLUX(IF,IR,IG,3) - FLUX(IF,IR,IG,2))
            FLUX(IF,IR,IG,2) = FLUX(IF,IR,IG,1) + DMU *
     >        (FLUX(IF,IR,IG,2) - FLUX(IF,IR,IG,1))
   11     CONTINUE
   12     CONTINUE
   13  CONTINUE
       AKEEP(3)= AKEEP(2) + DMU * (AKEEP(3)-AKEEP(2))
       AKEEP(2)= AKEEP(1) + DMU * (AKEEP(2)-AKEEP(1))
      ELSE
       MU= 1.0
      ENDIF
C
      RETURN
      END
