*DECK MOC2HM
      SUBROUTINE MOC2HM(NGRP,NREG,NANIS,NMAT,NFUNL,NIFIS,KEYANI,MATCOD,
     >                  VOL,FLUX,
     >                  XSTOT,XSTRC,XSDIA,XSCAT,XSNUF,XSCHI,
     >                  PHI,
     >                  XCTOT,XCTRC,XCDIA,XCCAT,XCNUF,XCCHI,XCABS,
     >                  IPRT )
C
C     HOMOGENIZE CROSS SECTIONS OVER ALL CELL
C
      IMPLICIT NONE
      INTEGER NGRP,NREG,NANIS,NMAT,NFUNL,MATCOD(NREG),KEYANI(NANIS)
      INTEGER IGRP,IREG,IANI, IPRT, JGRP, IFIS, NIFIS,IOUT
      REAL    FLUX(NFUNL,NREG,NGRP),VOL(NREG),
     >        XSTOT(0:NMAT,NGRP),XSTRC(0:NMAT,NGRP),XSDIA(0:NMAT,NGRP),
     >        XSCAT(NGRP,0:NMAT,0:NANIS,NGRP),
     >        XSNUF(0:NMAT,NIFIS,NGRP),XSCHI(0:NMAT,NIFIS,NGRP)
      DOUBLE PRECISION XCTOT(NGRP),XCABS(NGRP),XCCAT(NGRP,0:NANIS,NGRP),
     >        XCNUF(NGRP),XCCHI(NGRP),XCTRC(NGRP),XCDIA(NGRP),
     >        PHIC,F2NP1,PHI(NGRP),FISOUR,AKINV,DZERO,DONE
      PARAMETER (IOUT=6,DZERO= 0.0D0, DONE=1.0D0 )
C
      AKINV= DZERO
      DO 50 IGRP= 1, NGRP
         PHI  (IGRP)= DZERO
         XCTOT(IGRP)= DZERO
         XCTRC(IGRP)= DZERO
         XCDIA(IGRP)= DZERO
         XCCHI(IGRP)= DZERO
         XCNUF(IGRP)= DZERO
         DO 10 IREG= 1, NREG
            PHIC= FLUX(1,IREG,IGRP)*VOL(IREG)
C
C           VOLUME-WEIGHTED FLUX SOLUTION
            PHI(IGRP)  = PHI(IGRP) + PHIC
            XCTOT(IGRP)= XCTOT(IGRP)
     >                 + XSTOT(MATCOD(IREG),IGRP)*PHIC
            XCTRC(IGRP)= XCTRC(IGRP)
     >                 + XSTRC(MATCOD(IREG),IGRP)*PHIC
            XCDIA(IGRP)= XCDIA(IGRP)
     >                 + XSDIA(MATCOD(IREG),IGRP)*PHIC
            DO 11 IFIS= 1, NIFIS
               XCNUF(IGRP)= XCNUF(IGRP)
     >                    + XSNUF(MATCOD(IREG),IFIS,IGRP)*PHIC
               AKINV= AKINV
     >                    + XSNUF(MATCOD(IREG),IFIS,IGRP)*PHIC
   11       CONTINUE
   10    CONTINUE
C
         XCTOT(IGRP)= XCTOT(IGRP)/PHI(IGRP)
         XCTRC(IGRP)= XCTRC(IGRP)/PHI(IGRP)
         XCDIA(IGRP)= XCDIA(IGRP)/PHI(IGRP)
         XCABS(IGRP)= XCTOT(IGRP)
         XCNUF(IGRP)= XCNUF(IGRP)/PHI(IGRP)
         DO 40 JGRP= 1, NGRP
            DO 45 IANI= 0, NANIS
               XCCAT(IGRP,IANI,JGRP)= DZERO
               DO 30 IREG= 1, NREG
                     XCCAT(IGRP,IANI,JGRP)= XCCAT(IGRP,IANI,JGRP)+
     >               XSCAT(IGRP,MATCOD(IREG),IANI,JGRP)*
     >                          FLUX(1,IREG,IGRP)*VOL(IREG)
   30          CONTINUE
               XCCAT(IGRP,IANI,JGRP)= XCCAT(IGRP,IANI,JGRP)/PHI(IGRP)
   45       CONTINUE
            XCABS(IGRP)= XCABS(IGRP)-XCCAT(IGRP,0,JGRP)
   40    CONTINUE
C
C***      OBSOLETE
C         PHI(IGRP)= PHI(IGRP)*VOLINV*AKINV
C
   50 CONTINUE
      AKINV= DONE/AKINV
      DO 90 IREG= 1, NREG
         DO 80 IFIS= 1, NIFIS
            FISOUR= DZERO
            DO 60 IGRP= 1, NGRP
               FISOUR= FISOUR+
     >          XSNUF(MATCOD(IREG),IFIS,IGRP)*FLUX(1,IREG,IGRP)
   60       CONTINUE
            DO 70 IGRP= 1, NGRP
               XCCHI(IGRP)= XCCHI(IGRP)+
     >          XSCHI(MATCOD(IREG),IFIS,IGRP)*FISOUR*VOL(IREG)
   70       CONTINUE
   80    CONTINUE
   90 CONTINUE
      DO 100 IGRP= 1, NGRP
         XCCHI(IGRP)= XCCHI(IGRP)*AKINV
  100 CONTINUE
      IF( IPRT.GT.5 )THEN
         WRITE(IOUT,6000)
         WRITE(IOUT,6021)
         DO 1000 IGRP= 1, NGRP
            WRITE(IOUT,6023) IGRP,PHI(IGRP),
     >      XCTOT(IGRP),XCABS(IGRP),
     >      XCNUF(IGRP),XCCHI(IGRP),XCCAT(IGRP,0,IGRP),
     >      XCTOT(IGRP)-XCABS(IGRP)-XCCAT(IGRP,0,IGRP)
 1000    CONTINUE
         IF( IPRT.GT.10 )THEN
            DO 2000 IANI= 0, NANIS
               F2NP1= 1./(2.*REAL(IANI)+1.)
               WRITE(IOUT,6029) IANI,1,(JGRP,JGRP=1,NGRP)
               DO 1500 IGRP= 1, NGRP
                  WRITE(IOUT,6028) IGRP,
     >                   (XCCAT(IGRP,IANI,JGRP)*F2NP1,JGRP=1,NGRP)
 1500          CONTINUE
 2000       CONTINUE
         ENDIF
      ENDIF
      RETURN
 6000 FORMAT(/' F L U X E S   A N D   H O M O G E N I Z E D   X - S'/
     > 1X,51(1H-))
 6021 FORMAT(1X,'GROUP',4X,'AVERAGE',8X,'TOTAL',7X,
     >'ABSORPTION',5X,'NUSIGF',8X,'FISSION',10X,'SCATTERING X-S'/11X,
     >'FLUX',11X,'X-S',11X,'X-S',10X,'X-S',
     >10X,'SPECTRUM',3X,'WITHIN GROUP',2X,'OUT OF GROUP')
 6023 FORMAT(1X,I4,1P,8E14.5)
 6028 FORMAT(3H I=,I4,2H: ,1P,10E12.4/(9X,10E12.4))
 6029 FORMAT(/' ORDER OF LEGENDRE: ',I2
     > /' SCATTERING TRANSFER X-S (I TOWARD J) IN REGION',I5,1H:
     > //(11X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,
     > I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,
     > 2HJ=,I4))
      END
