*DECK SADEVO
      SUBROUTINE SADEVO(IPLIB ,IKLIB ,IPFLUX,IKFLUX,IPTRK ,NDEPL ,NCOMB,
     >                  NBISO ,NREGCE,IPRINT, 
     >                  ADJSOU,ISONDP,MILVO                )
C
C-----------------------------------------------------------------------
C
C DRIVER FOR AN ISOTOPIC DEPLETION CALCULATION.
C
C INPUT/OUTPUT PARAMETERS:
C
C LINKED LIST / XSM FILE: (ORDER IS ARBITRARY FOR 2,3,4,5)
C
C
C--------------ORIGINAL VERSION AUTHOR: A. HEBERT ; 09/11/94 ---
C--------------ORIGINAL VERSION MODIF : G.M.      ; 97-02-12 ---
C
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE,NDPROC,NTC,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NSTATE=40,NDPROC=20,NTC=3,ILCMUP=1,
     >            ILCMDN=2,NAMSBR='SADEVO')
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     IMAT,IVOL,IIDL,
     >            JJMIX,JJDEN,ISONAM,ISONRF,ISOAWR,JFLUXE,IFUNKN,
     >            ITIMES,LMASKM,LMASKG,IJM,IYDPL,
     >            IFLX,IVX,ISOCMB
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   HSMG*131,HSIGN*12,TEXT12*12
      INTEGER     ISTATE(NSTATE),KCHAR(NTC),IPDEPL,ITC,NPRODE,
     >            IPFLUX,IKFLUX,IPTRK,IPLIB,IEN,IKLIB,
     >            IPLIBO,NREG,NUN,NGMIX,MAXMIX,NBISO,
     >            NGROUP,NL,NDEPL,NCOMB,NPROC,IGR,KEYFLX,IPRINT,
     >            ISAVE,ISET,ITIXS,INR,INDREC,ITYPE,
     >            NREGCE,IGLOB,IEXTR,NTIME,IREG
      REAL        RPAR(5),XT(5)
      INTEGER     ISONDP(2,NBISO),MILVO(NREGCE)
      DOUBLE PRECISION  ADJSOU(*)
      WRITE(6,*) ' MONCHAI  RUNNING SADEVO1'
      IF (IKLIB .GT. 0) THEN
C--     --- IF L_LIBRARY SIGNATURE, USE LINKLIST FILE--
        CALL LCMOP(IPDEPL,'IPDEPL',0,1,0)    
      ELSE
        CALL XABORT(NAMSBR//
     >  ': L_LIBRARY SIGNATURE IN IPLIB REQUIRED.')
      ENDIF
      HSIGN='L_BURNUP'
      READ(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,NTC)
      CALL LCMPUT(IPDEPL,'SIGNATURE',3,3,KCHAR)
C----
C  RECOVER TRACKING INFORMATION
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      NREG=ISTATE(1)
      NUN=ISTATE(2)
      NGMIX=ISTATE(4)
      CALL SETARA(IBASE,NREG,IMAT)
      CALL SETARA(RBASE,NREG,IVOL)
      CALL SETARA(IBASE,NREG,IIDL)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL LCMGET(IPTRK,'VOLUME',RBASE(IVOL))
      CALL LCMGET(IPTRK,'KEYFLX',IBASE(IIDL))
C----
C  RECOVER GENERAL INTERNAL LIBRARY INFORMATION.
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPLIB,'STATE-VECTOR',ISTATE)
      MAXMIX=ISTATE(1)
      NBISO=ISTATE(2)
      NGROUP=ISTATE(3)
      NL=ISTATE(4)
      NDEPL=ISTATE(11)
      NCOMB=ISTATE(12)
      NPROC=NDPROC+NL
      NPRODE=ISTATE(18)
      IF(NGMIX .GT. MAXMIX) THEN
         WRITE(HSMG,9000) NAMSBR,NGMIX,MAXMIX
         CALL XABORT(HSMG)
      ENDIF
      CALL SETARA(IBASE,NBISO,JJMIX)
      CALL SETARA(RBASE,NBISO,JJDEN)
      CALL SETARA(IBASE,3*NBISO,ISONAM)
      CALL SETARA(IBASE,3*NBISO,ISONRF)
      CALL SETARA(RBASE,NBISO,ISOAWR)
      CALL LCMGET(IPLIB,'ISOTOPESMIX ',IBASE(JJMIX))
      CALL LCMGET(IPLIB,'ISOTOPESDENS',RBASE(JJDEN))
      CALL LCMGET(IPLIB,'ISOTOPESUSED',IBASE(ISONAM))
      CALL LCMGET(IPLIB,'ISOTOPERNAME',IBASE(ISONRF))
      CALL LCMGET(IPLIB,'ISOTOPESAWR ',RBASE(ISOAWR))
C----
C  RECOVER AVERAGE NEUTRON FLUXES INFORMATION.
C----
      CALL SETARA(RBASE,NREG*NGROUP,JFLUXE)
      IF(IKFLUX .NE. 0) THEN
        CALL SETARA(RBASE,NUN,IFUNKN)
        CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMUP)
        DO 120 IGR=1,NGROUP
          WRITE(TEXT12,'(4HFLUX,I3)') IGR
          CALL LCMGET(IPFLUX,TEXT12,RBASE(IFUNKN))
          DO 121 IREG=1,NREG
            KEYFLX=IBASE(IIDL+IREG-1)
            RBASE(JFLUXE+(IGR-1)*NREG+IREG-1)=RBASE(IFUNKN+KEYFLX-1)
 121      CONTINUE
 120    CONTINUE
        CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMDN)
        CALL RLSARA(RBASE(IFUNKN))
      ELSE
        CALL XDRSET(RBASE(JFLUXE),NREG*NGROUP,0.0)
      ENDIF
C----
C  READ THE BURNUP PARAMETERS.
C----
      ISAVE=0
      ISET=0
      ITIXS=0
      INR=-1
      XT(1)=0.0
      XT(2)=0.0
      XT(3)=0.0
      XT(4)=0.0
      XT(5)=0.0
      INDREC=1
      RPAR(1)=1.0E-5
      RPAR(2)=1.0E-4
      RPAR(3)=80.0
      RPAR(4)=1.0E-4
      RPAR(5)=35.0
      ITYPE=2
      NTIME=0
      IEXTR=0
      IGLOB=1
      INR=2
      CALL SETARA(RBASE,NTIME+2,ITIMES)
      CALL XDRSET(RBASE(ITIMES),NTIME+2,0.0)
      IF(INR .GT. 0) THEN
        IF(IKFLUX .EQ. 0) CALL XABORT(NAMSBR//
     >  ': FOR POWER/FLUX BURNUP A FLUXUNK DATA STRUCTURE REQUIRED.')
      ENDIF
      IF(MAXMIX .EQ. 0) CALL XABORT(NAMSBR//
     >'SADEVO: MAXMIX NOT YET DEFINED.')
      IF(NREG .EQ. 0) CALL XABORT(NAMSBR//
     >': NREG = 0')
      IF(NDEPL .EQ. 0) CALL XABORT(NAMSBR//
     >': NO DEPLETING ISOTOPES.')
      IF(NCOMB .EQ. 0) CALL XABORT(NAMSBR//
     >': NO DEPLETING MIXTURES.')
      IF(INR .EQ. -1) CALL XABORT(NAMSBR//
     >': TYPE OF DEPLETION NOT DEFINED.')
      NREGCE=NPRODE+NCOMB
      CALL SETARA(IBASE,MAXMIX,LMASKM)
      CALL SETARA(IBASE,NGROUP,LMASKG)
      CALL SETARA(IBASE,NDEPL*NREGCE,IJM)
      CALL SETARA(RBASE,(NDEPL+1)*NREGCE*2,IYDPL)
      CALL SETARA(RBASE,NGROUP*NREGCE*2,IFLX)
      CALL SETARA(RBASE,NREGCE,IVX)
      CALL SETARA(IBASE,NDEPL*NREGCE,ISOCMB)
      CALL SADEDR(IPDEPL,IPLIB ,IPRINT,INDREC,NBISO ,NGROUP,
     >            MAXMIX,NREG  ,NTIME ,NPROC ,NDEPL ,NCOMB ,
     >            NREGCE,ITYPE ,INR   ,ISAVE ,ITIXS ,RPAR  ,
     >            XT    ,
     >            IBASE(ISONAM),IBASE(ISONRF),RBASE(ISOAWR),
     >            ISONDP       ,RBASE(ITIMES),IBASE(JJMIX) ,
     >            RBASE(JJDEN) ,IBASE(IMAT)  ,RBASE(IVOL)  ,
     >            RBASE(JFLUXE),IBASE(LMASKM),IBASE(LMASKG),
     >            IBASE(IJM)   ,MILVO        ,RBASE(IYDPL) ,
     >            RBASE(IFLX)  ,RBASE(IVX)   ,IBASE(ISOCMB),
     >            ADJSOU )
      CALL RLSARA(IBASE(ISOCMB))
      CALL RLSARA(RBASE(IVX))
      CALL RLSARA(RBASE(IFLX))
      CALL RLSARA(RBASE(IYDPL))
      CALL RLSARA(IBASE(IJM))
      CALL RLSARA(IBASE(LMASKG))
      CALL RLSARA(IBASE(LMASKM))
C----
C  RELEASE FINAL MEMORY
C----
      CALL RLSARA(RBASE(ITIMES))
      CALL RLSARA(RBASE(JFLUXE))
      CALL RLSARA(RBASE(ISOAWR))
      CALL RLSARA(IBASE(ISONRF))
      CALL RLSARA(IBASE(ISONAM))
      CALL RLSARA(RBASE(JJDEN))
      CALL RLSARA(IBASE(JJMIX))
      CALL RLSARA(IBASE(IIDL))
      CALL RLSARA(RBASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      CALL LCMCL(IPDEPL,2)
      RETURN
C----
C  ERROR FORMAT
C----
 9000 FORMAT(A6,': NUMBER OF MIXTURES IN TRACKING = ',I5,
     >          ' GREATER THAN NUMBER OF MIXTURES IN',
     >          ' INTERNAL LIBRARY =',I5,'.')
      END